/*
 * Copyright (C) 2015 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.pixscape;

import java.util.Arrays;
import java.util.Set;
import javax.swing.table.DefaultTableModel;
import org.thema.pixscape.metric.MetricDialog;
import org.thema.pixscape.metric.ViewShedMetric;
import org.thema.pixscape.metric.ViewTanMetric;
import org.thema.pixscape.view.ViewResult;
import org.thema.pixscape.view.ViewShedResult;
import org.thema.pixscape.view.ViewTanResult;

/**
 * Dialog form for showing results for interactive metric calculation
 * @author Gilles Vuidel
 */
public class MetricResultDialog extends javax.swing.JDialog {

    private boolean isTan;
    private ViewResult result;
    private Set<Integer> codes;
    
    /** 
     * Creates new form MetricResultDialog 
     * @param parent the parent frame
     * @param isTan is tangential view ? or planimetric ?
     * @param codes the landuse codes
     */
    public MetricResultDialog(java.awt.Window parent, boolean isTan, Set<Integer> codes) {
        super(parent);
        initComponents();
        setLocationRelativeTo(parent);
        this.codes = codes;
        this.isTan = isTan;
    }

    /**
     * Sets the view result and update metrics if the form is visible.
     * @param result 
     */
    public void setResult(ViewResult result) {
        this.result = result;
        if(isVisible()) {
            updateMetric();
        }
    }
    
    /**
     * Calculates the metrics and update values in the table
     */
    private void updateMetric() {
        if(result == null) {
            return;
        }
        for(int i = 0; i < table.getRowCount(); i++) {
            Double[] res;
            if(isTan) {
                res = ((ViewTanMetric)table.getValueAt(i, 0)).calcMetric((ViewTanResult) result);
            } else {
                res = ((ViewShedMetric)table.getValueAt(i, 0)).calcMetric((ViewShedResult) result);
            }
            table.setValueAt(Arrays.deepToString(res), i, 1);
        }
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        table = new javax.swing.JTable();
        addButton = new javax.swing.JButton();
        remButton = new javax.swing.JButton();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle"); // NOI18N
        setTitle(bundle.getString("MetricResultDialog.title")); // NOI18N
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });

        table.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Metric", "Value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(table);

        addButton.setText(bundle.getString("MetricResultDialog.addButton.text")); // NOI18N
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        remButton.setText(bundle.getString("MetricResultDialog.remButton.text")); // NOI18N
        remButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                remButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addComponent(addButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 120, Short.MAX_VALUE)
                .addComponent(remButton))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 189, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(addButton)
                    .addComponent(remButton)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        MetricDialog dlg = new MetricDialog(this, isTan, codes);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        Double [] res = null;
        if(result != null) {
            if(isTan) {
                res = ((ViewTanMetric)dlg.metric).calcMetric((ViewTanResult) result);
            } else {
                res = ((ViewShedMetric)dlg.metric).calcMetric((ViewShedResult) result);
            }
        }
        ((DefaultTableModel)table.getModel()).addRow(new Object[]{dlg.metric, Arrays.deepToString(res)});
    }//GEN-LAST:event_addButtonActionPerformed

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
       updateMetric();
    }//GEN-LAST:event_formComponentShown

    private void remButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_remButtonActionPerformed
        for(int i = table.getRowCount()-1; i >= 0; i--) {
            if(table.getSelectionModel().isSelectedIndex(i)) {
                ((DefaultTableModel)table.getModel()).removeRow(i);
            }
        }
        
    }//GEN-LAST:event_remButtonActionPerformed

    
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton remButton;
    private javax.swing.JTable table;
    // End of variables declaration//GEN-END:variables

}
